#include <mex.h>

/*transforms sample2node matrix to proximity matrix*/
void mexFunction( int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
    if (nrhs!=1){
        mexErrMsgTxt("One argument expected\n");
    }
    
    double *sample2node = mxGetPr(prhs[0]);
    int samplesCount = mxGetM(prhs[0]), treeCount = mxGetN(prhs[0]);
    
    if (nlhs>0){
        
        plhs[0]= mxCreateDoubleMatrix(samplesCount,samplesCount,mxREAL);
        double *out = mxGetPr(plhs[0]);
        int ijidx1,ijidx2;
    
        for(int i=0; i<samplesCount; i++){
            for(int j=i+1; j<samplesCount; j++){
                ijidx1 = i*samplesCount + j;
                ijidx2 = j*samplesCount + i;
                //count the number of trees, where i and j have the same number
                for (int t=0; t<treeCount; t++){
                    if (sample2node[t*samplesCount+i] == sample2node[t*samplesCount+j]){
                        out[ijidx1]++;
                        out[ijidx2]++;
                    }
                }
                out[ijidx1] = out[ijidx1]/treeCount;
                out[ijidx2] = out[ijidx2]/treeCount;
            }  
        }
    }

}
