function yhat = weakTest(model, X, opts)
% X is NxD as usual. 
% see weakTrain for more info.

[N, D]= size(X);

if model(opts.mwIDidx)== 1
    
    % Decision stump classifier
    idx = opts.index{model(opts.mwIDidx)};
    yhat = double(X(:, model(idx.ridx)) < model(idx.tidx));

elseif model(opts.mwIDidx)== 2
    
    % 2-D linear clussifier stump
    idx = opts.index{model(opts.mwIDidx)};
    yhat = double([X(:, [model(idx.r1idx), model(idx.r2idx)]), ones(N, 1)]*model(idx.widx) < 0);
    
elseif model(opts.mwIDidx)== 3
    
    % 2-D conic section learner
    idx = opts.index{model(opts.mwIDidx)};
    r1= model(idx.r1idx);
    r2= model(idx.r2idx);
    phi= [X(:, r1).*X(:, r2), X(:,r1).^2, X(:,r2).^2, X(:, r1), X(:, r2), ones(N, 1)];
    mv= phi*model(idx.widx);
    yhat = double(mv<model(idx.t2idx) & mv>model(idx.t1idx));
    
elseif model(opts.mwIDidx)== 4
    
    % RBF, distance based learner
    idx = opts.index{model(opts.mwIDidx)};
    yhat= double(pdist2(X, model(idx.xidx)) < model(idx.tidx));

elseif model(opts.mwIDidx)== 5

    idx = opts.index{model(opts.mwIDidx)};

    yhat = double([X(:, [model(idx.r1idx), model(idx.r2idx), model(idx.r3idx)]), ones(N, 1)]*model(idx.widx) < 0);

elseif model(opts.mwIDidx)== 0
    
    %send all data in one direction
    yhat= ones(N,1); 

else
    fprintf('Error in weak test! Classifier with ID = %d does not exist.\n', opts.wmIDidx);
end


end